#!/usr/bin/python
import threading
import champFT
import gtk
import common
import numpy as np
import time
import struct
import socket
import copy
import os
import camStructures
import IRCamCommands

from os import O_WRONLY, O_TRUNC, O_CREAT
from stat import S_IRUSR, S_IWUSR, S_IRGRP, S_IWGRP

#####################################################################
# now using numpy
# numarray fromstring(datastring, type, shape=None)
# numpy fromstring(string, dtype=float, count=-1, sep='')
# numarray na.Float32
# numpy np.float32
#####################################################################

####################################################
### Plots currently implemented (FB, 2011-02-1)
### FLUX-vs-OPD
### AMP-vs-OPD
### FLUX-vs-T
### PHIS-vs-T
### Delay-vs-T
####################################################

class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''

class socketThread(threading.Thread):
    def __init__(self, name='TestThread'):
        """ constructor, setting initial variables """
        self._stopevent = threading.Event()
        self._sleepperiod = 0.4
        threading.Thread.__init__(self, name=name)
	self.smessage = sMessage()
        
    def initSocket(self):
        self.sock = None     
        for res in socket.getaddrinfo(common.host, common.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readFLUXvsOPD(self):   #request flux of most current scan
        print "Read FLUXvsOPD"
	self.smessage.length = common.numberOfFrames * common.MAXCOMBOS * 4
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFLUXvsOPD = 0
        else:
            self.flagSockFLUXvsOPD = 1
            self.sock.settimeout(30)
            self.sock.send('FX')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.FLUXvsOPDArr = np.fromstring(data, np.float32, (common.MAXCOMBOS*common.numberOfFrames)).reshape((common.MAXCOMBOS, common.numberOfFrames))

#            print common.FLUXvsOPDArr


    def readAMPvsOPD(self):
        print "Read AMPvsOPD"
	self.smessage.length = 4 + 6*6*4 + 6*common.numberOfFrames*4 + 6*common.numberOfFrames * 4
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockAMPvsOPD = 0
        else:
            self.flagSockAMPvsOPD = 1
            self.sock.settimeout(30)
            self.sock.send('AM')
            self.sock.send(struct.pack('L', self.smessage.length))

            #receive length of message
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
	
            #get FIT parameters
            self.smessage.length = 6*6 * 4     #6*6 floats
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data

            common.AMPvsOPDArrFIT = np.fromstring(data, np.float32, 6*6).reshape(6,6)

            #get OPD
            self.smessage.length = 12*common.numberOfFrames/2 * 4    #12*21 floats
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data

            common.AMPvsOPDArrOPD = np.fromstring(data, np.float32, (12*common.numberOfFrames/2)).reshape(12, common.numberOfFrames/2)

            #get AMP
            self.smessage.length = 12*common.numberOfFrames/2 * 4    #12*21 floats
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()

            common.AMPvsOPDArrAMP = np.fromstring(data, np.float32, (12*common.numberOfFrames/2)).reshape(12, common.numberOfFrames/2)

            #print common.AMPvsOPDArrFIT
            #print common.AMPvsOPDArrOPD
            #print common.AMPvsOPDArrAMP


    def readFLUXvsT(self):
        print "Read FLUXvsT"
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFLUXvsT = 0
        else:
            self.flagSockFLUXvsT = 1
            self.sock.settimeout(30)
            self.sock.send('HF')
            #self.smessage.length = 4
            #self.sock.send(struct.pack('L', self.smessage.length))

            #common.FLUXvsTArrScanNrLast = 0

            #send last scan number
            c_struct = struct.pack(
                'i',
                common.FLUXvsTArrScanNrLast
                )
            strLen = len(c_struct)
            self.sock.send(c_struct)
            print "Last Scan Nr.:"
            print common.FLUXvsTArrScanNrLast
	 
            #receive length of message
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            dataLengths = np.fromstring(data, np.uint32, 1)

            #receive current new scan number
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            common.FLUXvsTArrScanNrNew = np.fromstring(data, np.uint32, 1)
            newscans = (dataLengths-4)/12/4
            
            #get FLUX
            self.smessage.length = 12 * newscans * 4     #12*newscans floats
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            ArrTmp = np.zeros([12,newscans], dtype=np.float32)
            data2 = np.fromstring(data, np.float32, (12*newscans))
            i = -1
            for SCAN in range(newscans):
                for CH in range(12):
                    i = i+1
                    ArrTmp[CH][SCAN] = data2[i]

            ArrTmp2 = np.append(common.FLUXvsTArr, ArrTmp, axis=1)
            
            if ArrTmp2.shape[1] > common.FTMEMORY:
                print "CASE1"
                common.FLUXvsTArr = ArrTmp2[:,(ArrTmp2.shape[1]-common.FTMEMORY):(ArrTmp2.shape[1])]
            else:
                print "CASE2"
                common.FLUXvsTArr = ArrTmp2
            print common.FLUXvsTArr.shape[0], common.FLUXvsTArr.shape[1]

            common.FLUXvsTArrScanNrLast = common.FLUXvsTArrScanNrNew

    def readDELAYvsT(self):
        print "Read DELAYvsT"
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockDELAYvsT = 0
        else:
            self.flagSockDELAYvsT = 1
            self.sock.settimeout(30)
            self.sock.send('HD')

            #send last scan number
            c_struct = struct.pack(
                'i',
                common.DELAYvsTArrScanNrLast
                )
            strLen = len(c_struct)
            self.sock.send(c_struct)
            print "Last Scan Nr.:"
            print common.DELAYvsTArrScanNrLast
	 
            #receive length of message
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            dataLengths = np.fromstring(data, np.uint32, 1)

            #receive current new scan number
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            common.DELAYvsTArrScanNrNew = np.fromstring(data, np.uint32, 1)
            newscans = (dataLengths-4)/ 6 / 4
            
            #get DELAY
            self.smessage.length = 6 *newscans * 4 
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            ArrTmp = np.zeros([6,newscans], dtype=np.float32)
            data2 = np.fromstring(data, np.float32, (6 * newscans))
            i = -1
            for SCAN in range(newscans):
                for CH in range(6):
                    i = i+1
                    ArrTmp[CH][SCAN] = data2[i]

            ArrTmp2 = np.append(common.DELAYvsTArr, ArrTmp, axis=1)
            
            if ArrTmp2.shape[1] > common.FTMEMORY:
                print "CASE1"
                common.DELAYvsTArr = ArrTmp2[:,(ArrTmp2.shape[1]-common.FTMEMORY):(ArrTmp2.shape[1])]
            else:
                print "CASE2"
                common.DELAYvsTArr = ArrTmp2
            print common.DELAYvsTArr.shape[0], common.DELAYvsTArr.shape[1]

            common.DELAYvsTArrScanNrLast = common.DELAYvsTArrScanNrNew
            
    def readPHIvsT(self):
        print "Read PHIvsT"
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockPHIvsT = 0
        else:
            self.flagSockPHIvsT = 1
            self.sock.settimeout(30)
            self.sock.send('HP')

            #send last scan number
            c_struct = struct.pack(
                'i',
                common.PHIvsTArrScanNrLast
                )
            strLen = len(c_struct)
            self.sock.send(c_struct)
            print "Last Scan Nr.:"
            print common.PHIvsTArrScanNrLast
	 
            #receive length of message
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            dataLengths = np.fromstring(data, np.uint32, 1)

            #receive current new scan number
            self.smessage.length = 4    #1 long
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            common.PHIvsTArrScanNrNew = np.fromstring(data, np.uint32, 1)
            newscans = (dataLengths-4)/ 6 / 4
            
            #get PHI
            self.smessage.length = 6 *newscans * 4 
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            ArrTmp = np.zeros([6,newscans], dtype=np.float32)
            data2 = np.fromstring(data, np.float32, (6 * newscans))
            i = -1
            for SCAN in range(newscans):
                for CH in range(6):
                    i = i+1
                    ArrTmp[CH][SCAN] = data2[i]

            ArrTmp2 = np.append(common.PHIvsTArr, ArrTmp, axis=1)
            
            if ArrTmp2.shape[1] > common.FTMEMORY:
                print "CASE1"
                common.PHIvsTArr = ArrTmp2[:,(ArrTmp2.shape[1]-common.FTMEMORY):(ArrTmp2.shape[1])]
            else:
                print "CASE2"
                common.PHIvsTArr = ArrTmp2
            print common.PHIvsTArr.shape[0], common.PHIvsTArr.shape[1]

            common.PHIvsTArrScanNrLast = common.PHIvsTArrScanNrNew
            


    def run(self):
        """ main control loop """
        print "%s starts" % (self.getName(),)
        while not self._stopevent.isSet():
            plotNeeded = 0
            for i in range(common.plotType.shape[0]):
                if common.plotType[i] == common.plotFLUXvsOPD and common.liveDisplayStatus == 1: plotNeeded = 1
            if plotNeeded == 1:
                self.readFLUXvsOPD()
                if self.flagSockFLUXvsOPD: common.dataReadyFLUXvsOPD = 1
            
            plotNeeded = 0
            for i in range(common.plotType.shape[0]):
                if common.plotType[i] == common.plotAMPvsOPD and common.liveDisplayStatus == 1: plotNeeded = 1
            if plotNeeded == 1:
                self.readAMPvsOPD()
                if self.flagSockAMPvsOPD: common.dataReadyAMPvsOPD = 1


                plotNeeded = 0
            for i in range(common.plotType.shape[0]):
                if common.plotType[i] == common.plotPHIvsT and common.liveDisplayStatus == 1: plotNeeded = 1
            if plotNeeded == 1:
                self.readPHIvsT()
                if self.flagSockPHIvsT: common.dataReadyPHIvsT = 1


            plotNeeded = 0
            for i in range(common.plotType.shape[0]):
                if common.plotType[i] == common.plotDELAYvsT and common.liveDisplayStatus == 1: plotNeeded = 1
            if plotNeeded == 1:
                self.readDELAYvsT()
                if self.flagSockDELAYvsT: common.dataReadyDELAYvsT = 1

            plotNeeded = 0
            for i in range(common.plotType.shape[0]):
                if common.plotType[i] == common.plotFLUXvsT and common.liveDisplayStatus == 1: plotNeeded = 1
            if plotNeeded == 1:
                self.readFLUXvsT()
                if self.flagSockFLUXvsT: common.dataReadyFLUXvsT = 1


	    self._stopevent.wait(self._sleepperiod)
                
        print "%s ends" % (self.getName(),)
        
    def join(self, timeout=None):                                                                          
        """ Stop the thread. """
        self._stopevent.set()
        threading.Thread.join(self, timeout)


def main():
    #create a thread
    sockThread = socketThread()
    # starts the thread
    sockThread.start()   
    gtk.gdk.threads_init()
    #starts the gui
    champFT.ApplicationMainWindow()
    gtk.main()
    # stops the thread
    sockThread.join()

if __name__ == "__main__":
    main()

