#!/usr/bin/env python
"""
An animated image
"""
import matplotlib
import pylab as pl
from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.figure import Figure
import numpy as np
import common
import random
import time


class AnimatedImage:
    def __init__(self):
        bcnb = common.nBL
        plotnb = 4
        self.fig = Figure(figsize=(256,256))
        self.fig.subplots_adjust(left=0.05,right=0.98,hspace=0.,wspace=0.,top=0.98)
        self.a = {}
        self.b = {}
        self.c = {}
        self.d = {}
        self.intPlotA = 1
        self.intPlotB = 1
        self.intPlotC = 1
        self.intPlotD = 1
        self.lineAL = {}
        self.lineAR = {}
        self.lineB = {}
        self.lineC = {}
        self.lineD = {}
        for ndx, i in enumerate(range(1,bcnb+1)):
            self.a[ndx] = (self.fig.add_subplot(plotnb,bcnb,i))
            self.b[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+common.nBL))
            self.c[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+2*common.nBL))
            self.d[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+3*common.nBL))
            if i==1:
                self.a[ndx].set_xticklabels([])
                self.b[ndx].set_xticklabels([])
                self.c[ndx].set_xticklabels([])
            if i>1:
                self.a[ndx].set_xticklabels([])
                self.a[ndx].set_yticklabels([])
                self.b[ndx].set_xticklabels([])
                self.b[ndx].set_yticklabels([])
                self.c[ndx].set_xticklabels([])
                self.c[ndx].set_yticklabels([])
                self.d[ndx].set_yticklabels([])
        self.canvas = FigureCanvas(self.fig)

    def updateFig(self):
        if common.liveDisplayStatus and common.dataFluxReady:
            #Display Flux
            arr = np.zeros(common.numberOfFrames, dtype=np.float32)
            arr2 = np.zeros(common.numberOfFrames, dtype=np.float32)
            arr2L = np.zeros(common.numberOfFrames, dtype=np.float32)
            arr2R = np.zeros(common.numberOfFrames, dtype=np.float32)

            for ndx in range(common.nBL): 
                for npxFringe in range(common.numberOfFrames):
                    arr[npxFringe] = npxFringe
                    arr2L[npxFringe] = common.fluxArr[common.chNrL2Fringe[ndx]][npxFringe]
                    arr2R[npxFringe] = common.fluxArr[common.chNrR2Fringe[ndx]][npxFringe]

                if self.intPlotA:
                    print "HERE updateFig1"
                    #if common.activeFringe[ndx]:
                    self.lineAL[ndx], = self.a[ndx].plot(arr, arr2L, color='red')
                    self.lineAR[ndx], = self.a[ndx].plot(arr, arr2R, color='blue')
                    if ndx==common.nBL-1: self.intPlotA = 0
                    print "HERE updateFig1b"
                else:
                    print "HERE updateFig2"
                    self.lineAL[ndx].set_ydata(arr2L)
                    self.lineAR[ndx].set_ydata(arr2R)
                    print "HERE updateFig2a"
                
                    #self.a[ndx].update_datalim_numerix(max(self.lineAL[ndx].get_xdata(),self.lineAR[ndx].get_xdata()),max(self.lineAL[ndx].get_ydata(),self.lineAR[ndx].get_ydata()))
                    self.a[ndx].update_datalim_numerix(self.lineAL[ndx].get_xdata(),self.lineAL[ndx].get_ydata())
                    self.a[ndx].update_datalim_numerix(self.lineAR[ndx].get_xdata(),self.lineAR[ndx].get_ydata())
                    self.a[ndx].autoscale_view()
                    print "HERE updateFig2b"

            #Display FluxHist
            #print "Size of fluxArrHist array:"
            #print common.fluxArrHist.shape[2]
            #arr = np.zeros(common.fluxArrHist.shape[2], dtype=np.float32)
            #arr2 = np.zeros(common.fluxArrHist.shape[2], dtype=np.float32)

            #for ndx in range(common.nBL): 
            #    for npxFringe in range(common.fluxArrHist.shape[2]):
            #        arr[npxFringe] = npxFringe
            #        arr2[npxFringe] = common.fluxArrHist[ndx][npxFringe]

            #    if self.intPlotB:
            #        #if common.activeFringe[ndx]:
            #        self.lineB[ndx], = self.b[ndx].plot(arr, arr2)
            #        if ndx==common.nBL-1: self.intPlotB = 0
            #    else:
            #        print "HERE updateFig3"
            #        #if common.activeFringe[ndx]: 
            #        self.lineB[ndx].set_ydata(arr2)
            #        print "HERE updateFig3a"
            #    
            #        self.b[ndx].update_datalim_numerix(self.lineB[ndx].get_xdata(),self.lineB[ndx].get_ydata())
            #        self.b[ndx].autoscale_view()
            #        print "HERE updateFig3b"

            self.canvas.draw()   # redraw the canvas
            time.sleep(.3)

        common.dataFluxReady = 0
        return True
