import gtk
import sys
import struct   #http://python.org/doc/2.5.2/lib/module-struct.html
import numpy as np    #http://docs.scipy.org/doc/numpy/genindex.html
import socket
import common
import FTCommands
        
class setServerConfig(gtk.Window):
    def __init__(self,parent=None,tel1Entry=None,tel2Entry=None):
	self.ft = FTCommands.FTCommands()
	gtk.Window.__init__(self)
	self.set_screen(parent.get_screen())
        
	self.set_title('Host/Port configuration')
	self.set_default_size(200, 50)
	self.set_border_width(0)
	VBox = gtk.VBox(False, 0)
	self.add(VBox)
        
	### MODULATION ###
        table = gtk.Table(6,3)
	VBox.pack_start(table, False, False, 0)
        self.arrayConfig = {}
	label=gtk.Label('Host')
	table.attach(label, 0, 2, 0, 1, gtk.FILL,gtk.SHRINK,0,0)
	self.hostEntry = gtk.Entry()
	self.hostEntry.set_text(str(common.host))
	table.attach(self.hostEntry,2, 4, 0, 1, gtk.FILL,gtk.SHRINK,0,0)
	label=gtk.Label('Port')
	table.attach(label, 0, 2, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
	self.portEntry = gtk.Entry()
	self.portEntry.set_text(str(common.port))
	table.attach(self.portEntry,2, 4, 1 ,2, gtk.FILL,gtk.SHRINK,0,0)
	label=gtk.Label('Socket timeout')
	table.attach(label, 0, 2, 2, 3, gtk.FILL,gtk.SHRINK,0,0)
	self.timeoutEntry = gtk.Entry()
	self.timeoutEntry.set_text(str(common.timeout))
	table.attach(self.timeoutEntry,2, 4, 2, 3, gtk.FILL,gtk.SHRINK,0,0)
	button = gtk.Button('SET HOST')
        button.connect('clicked', self.setHost)
        table.attach(button,0, 1, 3, 4, gtk.FILL,gtk.SHRINK,0,0)
        self.show_all()
    
    def setHost(self, widget):
	common.host = self.hostEntry.get_text()
	common.port = int(self.portEntry.get_text())
	common.timeout = int(self.timeoutEntry.get_text())

class setArrayConfig(gtk.Window):
    def __init__(self,parent=None,tel1Entry=None,tel2Entry=None):
        self.ft = FTCommands.FTCommands()

        gtk.Window.__init__(self)
        self.set_screen(parent.get_screen())
        
        self.set_title('BC configuration')
        self.set_default_size(200, 50)
        self.set_border_width(0)
        VBox = gtk.VBox(False, 0)
        self.add(VBox)
        
	### MODULATION ###
        table = gtk.Table(6,3)
	VBox.pack_start(table, False, False, 0)
        self.arrayConfig = {}
	for i in range(6):
            label=gtk.Label('Fringe'+str(i+1))
            table.attach(label, i*2, (i+1)*2, 0, 1, gtk.FILL,gtk.SHRINK,0,0)
                
            self.arrayConfig[i] = gtk.combo_box_new_text()
            self.searchingModes = ['-', 'S1','S2', 'E1', 'E2', 'W1', 'W2']
            for mode in self.searchingModes:
                self.arrayConfig[i].append_text(mode)
            self.arrayConfig[i].set_active(0)
            table.attach(self.arrayConfig[i],i*2, (i+1)*2, 1, 2, gtk.FILL,gtk.SHRINK,0,0)

            self.arrayConfig[i+6] = gtk.combo_box_new_text()
            for mode in self.searchingModes:
                self.arrayConfig[i+6].append_text(mode)
            self.arrayConfig[i+6].set_active(0)
            table.attach(self.arrayConfig[i+6],i*2, (i+1)*2, 2, 3, gtk.FILL,gtk.SHRINK,0,0)

            if i == 0: self.arrayConfig[i].set_active(6)   #W2
            if i == 1: self.arrayConfig[i].set_active(2)   #S2
            if i == 2: self.arrayConfig[i].set_active(3)   #E1
            if i == 3: self.arrayConfig[i].set_active(5)   #W1
            if i == 0: self.arrayConfig[i+6].set_active(2)   #S2
            if i == 1: self.arrayConfig[i+6].set_active(3)   #E1
            if i == 2: self.arrayConfig[i+6].set_active(5)   #W1
            if i == 3: self.arrayConfig[i+6].set_active(6)   #W2

        button = gtk.Button('SAVE')
        button.connect('clicked', self.saveArrayConfig, parent)
        table.attach(button,0, 1, 3, 4, gtk.FILL,gtk.SHRINK,0,0)
        
        self.show_all()
        
### FRINGE TRACKER ###

    def saveArrayConfig(self, widget, parent):
        for i in range(6):
            parent.tel1Entry[i].set_text(str(self.searchingModes[self.arrayConfig[i].get_active()]))
            parent.tel2Entry[i].set_text(str(self.searchingModes[self.arrayConfig[i+6].get_active()]))

    def activate_setFTParameters(self, action):
        champControls.setFTParameters(parent=self)

class setPZTParameters(gtk.Window):
    def __init__(self, parent=None):
        self.ft = FTCommands.FTCommands()
        
        gtk.Window.__init__(self)
        self.set_screen(parent.get_screen())
        
        self.set_title('CHAMP PZT PARAMETERS')
        self.set_default_size(200, 150)
        self.set_border_width(0)
        ditherParametersVBox = gtk.VBox(False, 0)
        self.add(ditherParametersVBox)
        
	### MODULATION ###
	frame=gtk.Frame("Modulation")
	ditherParametersVBox.pack_start(frame, False, False, 0)
        table = gtk.Table(20,20)
	frame.add(table)
	#
	label = gtk.Label("Freq (Hz)")
        label.set_alignment(0,0)
        table.attach(label, 0, 1, 0, 1, gtk.FILL,gtk.SHRINK,0,0)
	entry = gtk.Entry()
	entry.set_size_request(60, 20)
	entry.set_text("%.2f"%(self.ft.dither_freq))
	entry.connect("activate", self.ftModSetEntry, 'freq')
        table.attach(entry, 1, 2, 0, 1, gtk.FILL,gtk.SHRINK,0,0)
	#
	label = gtk.Label("Amp (V)")
        label.set_alignment(0,0)
        table.attach(label, 0, 1, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
	entry = gtk.Entry()
	entry.set_size_request(60, 20)
	entry.set_text("%.2f"%(self.ft.dither_amp))
	entry.connect("activate", self.ftModSetEntry, 'amp')
        table.attach(entry, 1, 2, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
	#
	label = gtk.Label("OPD (micron)")
        label.set_alignment(0,0)
        table.attach(label, 0, 1, 2, 3, gtk.FILL,gtk.SHRINK,0,0)
	entry = gtk.Entry()
	entry.set_size_request(60, 20)
	entry.set_text("%.2f"%(self.ft.opdamp))
	entry.connect("activate", self.ftModSetEntry, 'opdamp')
        table.attach(entry, 1, 2, 2, 3, gtk.FILL,gtk.SHRINK,0,0)
	#
        label = gtk.Label("Smooth")
        label.set_alignment(0,0)
        table.attach(label, 0, 1, 3, 4, gtk.FILL,gtk.SHRINK,0,0)
        entry = gtk.Entry()
        entry.set_size_request(60, 20)
        entry.set_text("%.2f"%(self.ft.dither_smoothfrac))
        entry.connect("activate", self.ftModSetEntry, 'smoothfrac')
        table.attach(entry, 1, 2, 3, 4, gtk.FILL,gtk.SHRINK,0,0)
        #
        label = gtk.Label("Delay")
        label.set_alignment(0,0)
        table.attach(label, 0, 1, 4, 5, gtk.FILL,gtk.SHRINK,0,0)
        entry = gtk.Entry()
        entry.set_size_request(60, 20)
        entry.set_text("%.2f"%(self.ft.dither_delay))
        entry.connect("activate", self.ftModSetEntry, 'ditherdelay')
        table.attach(entry, 1, 2, 4, 5, gtk.FILL,gtk.SHRINK,0,0)
        
	# update button #
	vbox=gtk.VBox()
        button = gtk.Button("Update Server")
        button.connect("clicked", self.ftUpdateServer, '')
	vbox.pack_start(button,True,True,0)
	ditherParametersVBox.pack_start(vbox, False, False, 0)

        self.show_all()
        
    def ftModSetEntry(self, widget, data):
        entry = widget.get_text()
        if data == 'freq':
            self.ft.dither_freq = float(entry)
            print "new dither frequency = ",  self.ft.dither_freq

        elif data == 'amp':
            self.ft.dither_amp = float(entry)
            print "new dither amp = ",  self.ft.dither_amp

        elif data == 'opdamp':
            self.ft.opdamp = float(entry)
            print "new opdamp = ",  self.ft.opdamp


        elif data == 'smoothfrac':
            self.ft.dither_smoothfrac = float(entry)
            print "new dither smoothing frac = ",  self.ft.dither_smoothfrac

        elif data == 'ditherdelay':
            self.ft.dither_delay = float(entry)
            print "new dither delay frac = ",  self.ft.dither_delay

	else:
	   print "unknown request for ftModSetEntry"

    def ftUpdateServer(self,widget,data):
	print "Sending the following modulation params to server...."
	print "     dither frequency = ",  self.ft.dither_freq
	print "     dither amp = ",  self.ft.dither_amp
        print "     opd amp = ",  self.ft.opdamp
	print "     dither smoothing frac = ",  self.ft.dither_smoothfrac
	
	print "Sending the following beam params to server...."
	for i in range(6):
		print i,self.ft.active[i], self.ft.offset[i], self.ft.gain[i]	
        self.ft.updatePZTStructure()
                
class setServoParameters(gtk.Window):
    def __init__(self, parent=None):
        self.ft = FTCommands.FTCommands()
        
        gtk.Window.__init__(self)
        self.set_screen(parent.get_screen())
        
        self.set_title('CHAMP Parameters')
        self.set_default_size(200, 150)
        self.set_border_width(0)
        table = gtk.Table(20,20)
	self.add(table)

       	label = gtk.Label("SNR Threshold")
        table.attach(label, 2, 6, 0, 1, gtk.FILL,gtk.SHRINK,0,0)

	label = gtk.Label("Gain")
##         label.set_alignment(0,0)
        table.attach(label, 1, 2, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
       	label = gtk.Label("Search-to-SemiLock")
##         label.set_alignment(0,0)
        table.attach(label, 2, 3, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
	label = gtk.Label("SemiLock-to-Lock")
##         label.set_alignment(0,0)
        table.attach(label, 3, 4, 1, 2, gtk.FILL,gtk.SHRINK,0,0)	
	label = gtk.Label("Lock-to-SemiLock")
##         label.set_alignment(0,0)
        table.attach(label, 4, 5, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
        label = gtk.Label("SemiLock-to-Search")
##         label.set_alignment(0,0)
        table.attach(label, 5, 6, 1, 2, gtk.FILL,gtk.SHRINK,0,0)
	self.gainEntry = {}
	self.SNRThrS2SLEntry = {}
	self.SNRThrSL2LEntry = {}
	self.SNRThrL2SLEntry = {}
	self.SNRThrSL2SEntry = {}
	for i in range(6):
		label = gtk.Label('BC '+str(i+1)+' ')
                table.attach(label, 0, 1, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)
                
		self.gainEntry[i] = gtk.Entry()
		self.gainEntry[i].set_text("%.2f"%(self.ft.gain[i]))
                table.attach(self.gainEntry[i], 1, 2, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)
                
		self.SNRThrS2SLEntry[i] = gtk.Entry()
		self.SNRThrS2SLEntry[i] .set_text("%.2f"%(self.ft.SNRThrS2SL[i]))
                table.attach(self.SNRThrS2SLEntry[i], 2, 3, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)

		self.SNRThrSL2LEntry[i] = gtk.Entry()
		self.SNRThrSL2LEntry[i] .set_text("%.2f"%(self.ft.SNRThrSL2L[i]))
                table.attach(self.SNRThrSL2LEntry[i], 3, 4, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)

		self.SNRThrL2SLEntry[i] = gtk.Entry()
		self.SNRThrL2SLEntry[i] .set_text("%.2f"%(self.ft.SNRThrL2SL[i]))
                table.attach(self.SNRThrL2SLEntry[i], 4, 5, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)

		self.SNRThrSL2SEntry[i] = gtk.Entry()
		self.SNRThrSL2SEntry[i] .set_text("%.2f"%(self.ft.SNRThrSL2S[i]))
                table.attach(self.SNRThrSL2SEntry[i], 5, 6, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)


#		entry = gtk.Entry()
#		entry.set_text(str(self.ft.search_threshold[i]))
#		entry.connect("activate", self.ftTrackingUpdate, ['Lock thr',i])
#                table.attach(entry, 5, 6, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
	i+=1
	# update button #
        button = gtk.Button("Update Server")
        button.connect("clicked", self.ftUpdateServer, '')
	table.attach(button, 0, 2, i+2, i+3, gtk.FILL,gtk.SHRINK,0,0)
	
        self.show_all()
        
    def ftUpdateServer(self,widget,data):
	for i in range(6):
	    self.ft.gain[i]  = float(self.gainEntry[i].get_text())
	    self.ft.SNRThrS2SL[i] = float(self.SNRThrS2SLEntry[i].get_text())
	    self.ft.SNRThrSL2L[i] = float(self.SNRThrSL2LEntry[i].get_text())
	    self.ft.SNRThrL2SL[i] = float(self.SNRThrL2SLEntry[i].get_text())
	    self.ft.SNRThrSL2S[i] = float(self.SNRThrSL2SEntry[i].get_text())	    
        self.ft.updateServoStructure()

class offsetManager(gtk.Window):
    def __init__(self, parent=None):
        self.ft = FTCommands.FTCommands()
        
        gtk.Window.__init__(self)
        self.set_screen(parent.get_screen())
        
        self.set_title('CHAMP Parameters')
        self.set_default_size(200, 150)
        self.set_border_width(0)
        table = gtk.Table(20,20)
	self.add(table)
	label = gtk.Label("BC REF OFFSETS [mm]")
##         label.set_alignment(0,0)
        table.attach(label, 1, 2, 0, 1, gtk.FILL,gtk.SHRINK,0,0)

#	label = gtk.Label("DELAYS OFFSETS [mm]")
#        table.attach(label, 2, 3, 0, 1, gtk.FILL,gtk.SHRINK,0,0)	

	self.BCRefOffsetEntry = {}
#	self.delayOffsetEntry = {}

	for i in range(6):
		toggle = gtk.ToggleButton('BC '+str(i+1)+' ')
		toggle.connect("toggled", self.toggledBC, i)
                table.attach(toggle, 0, 1, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
                
		#gets off in microns from RT displays off in mm
		self.BCRefOffsetEntry[i] = gtk.Entry()
		self.BCRefOffsetEntry[i].set_text("%.3f"%(self.ft.BCRefOffset[i]*1e-3))
                table.attach(self.BCRefOffsetEntry[i], 1, 2, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
		
#                self.delayOffsetEntry[i] = gtk.Entry()
#                self.delayOffsetEntry[i].set_text("%.3f"%(self.ft.delayOffset[i]*1e-3))
#                table.attach(self.delayOffsetEntry[i], 2, 3, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
		
#		entry = gtk.Entry()
#		entry.set_text(str(self.ft.search_threshold[i]))
#		entry.connect("activate", self.ftTrackingUpdate, ['Lock thr',i])
#                table.attach(entry, 5, 6, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
	i+=2
	# update button #
        button = gtk.Button("SET BC REF OFF")
        button.connect("clicked", self.setBCRefOffset)
	table.attach(button, 1, 2, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
        #button = gtk.Button("SET DELAY OFF")
        #button.connect("clicked", self.setDelayOffset)
	#table.attach(button, 2, 3, i+1, i+2, gtk.FILL,gtk.SHRINK,0,0)
	
        self.show_all()
    
    def toggledBC(self, widget, i):
	toggled = {0:999, 1:1}
	self.ft.toggledBC[i] = toggled[widget.get_active()]
	print "self.ft.toggledBC[i] = ", self.ft.toggledBC[i]
        
    def setBCRefOffset(self,widget):
	for i in range(6):
	    #gets off in mm from displays send off in microns to RT
	    self.ft.BCRefOffset[i]  = float(self.BCRefOffsetEntry[i].get_text())*1e3
	self.ft.setBCRefOffset()
	
#    def setDelayOffset(self,widget):
#	for i in range(6):
#	    #gets off in mm from displays send off in microns to RT
#	    self.ft.delayOffset[i]  = float(self.delayOffsetEntry[i].get_text())*1e3
#	self.ft.setDelayOffset()
