#!/usr/bin/env python
    
# example base.py
import pygtk
pygtk.require('2.0')
import mounts
import gtk
import arrows
import picoData
import picoLowLevel
import numarray as PicoLib  
import sys	
	

"""!!!This Code and its comments have been optimized for viewing at size 14 courier font!!!"""


	
class Base(picoLowLevel.PicoControl):
	
	# End program on close
	def delete_event(self, widget,event, data=None):	#Starts the definition for function that closes program	
		print "delete event occurred"			#Prints out a notification to command window
		self.window.destroy()				#Closes the open window of the main program
		return False					#Returning false does something, pygtk told me to do it

	def destroy(self, widget, data=None):			#Starts another function for closing the program
		print "destroy signal occurred"			#Again prints out a notification to command window
		gtk.main_quit					#Quits the underlieing gtk program
		self.window.destroy()				#Closes the open window of the main program
		sys.exit()					#End-all quit line, shuts down all running code of program
		return False					#Again, not sure, just doing what I was told
	
	def __init__(self):					#Here begins the main code for the GUI window
		self.firsttime = True				#Flag variable used in opening the control panel on the GUI
		self.xpos = 0					#Initialization of the locations of x and y used later to show
		self.ypos = 0					#how far a pico motor is moved
		self.count = 1					#Count variable used later.
		self.ycol = 'black'				#Color flags denote current color of arrow keys on control panel
		self.xcol = 'black'

		# Start GUI Assembly
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)		#Creates new window for GUI and places it on top of the screen
		self.window.set_title("CHAMP Picomotor Control")	#Sets Window Title
		self.window.connect("delete_event", self.delete_event)	#Connects the x in corner of window to program ending function
		self.window.connect("destroy", self.destroy)		#Connects the x in corner of window to program ending function
		self.window.set_border_width(10)			#Sets the border width of the window
		
		self.table = gtk.Table(2,4 , False)	#Creates new table, 2 rows, 4 columns, False means all the cells do not have to be the 							same size
        	self.window.add(self.table)		#Adds the new table to the window
		self.window.show()		#Makes the window appear on-screen
		box = gtk.VBox(False, 0)	#Makes a box for buttons to be put on False denotes a non-expanding box, and 0 means
		box2 = gtk.VBox(False, 0)	#there will be no pixel padding around the box

		#Overhead Menu
		file_menu = gtk.Menu()			#Creates the internal menu that appears upon pull down	
		quit = gtk.MenuItem("Quit")		#Creates a pulldown menu item for quitting the program
		Zeroall = gtk.MenuItem("Zero All")	#Creates a pulldown menu item for zeroing all pico positions
		file_menu.append(Zeroall)		#Adds zero all item into the internal menu
		file_menu.append(quit)			#Adds quit item into the internal menu

		# Menu Bar Callbacks
		quit.connect("activate",self.destroy)		#Connects a click on the quit item to function that ends the program 
		quit.connect("activate", self.delete_event)	#Connects a click on the quit item to function that ends the program
		Zeroall.connect("activate", self.Zero_or_No)	#Connects a click on the zero all item to the zeroing confirmation
		menu_bar = gtk.MenuBar()			#Creates the toplevel menu bar across top of window


		#Attaching an item to the table widget follows the following format:
			#     table.attach(Whats being attached,left attach point, right attach point, top attach point, bottom attach point, X axis fitting can be 0 or gtk.FILL or gtk.EXPAND among others, Y axis fitting, X padding around table, Y padding around table.




		self.table.attach(menu_bar, 0,4,0,1, gtk.FILL, gtk.FILL,0,0);	#Attaches menu bar to table that is on the window
		menu_bar.show()					#Makes the menu bar visible on the window
		top_menu = gtk.MenuItem("Menu")			#Makes the top of the pull down menu that will appear on the menu bar
		top_menu.show()					#Makes the menu top menu item visible
		top_menu.set_submenu(file_menu)			#Adds the menu that already contains the zero and quit to the menu
		menu_bar.append(top_menu)			#Attaches the menu to the top menu item
		
		self.mount_buttons = self.create_mount_buttons()	#Calls a function that automatically creates the mount 
										#buttons for each picomotor on the table
		
		"""Menus are difficult to understand, there is very good documentation for making and understanding the menu making 			process available online at pygtk.com."""



		# Button for F-T.6
		self.mount_buttons[0].connect("clicked", self.mounts_callback,0)	#Connects a click on the picomotor button (denoted by number) to the callback function, the number of the picomotor is then passed to the callback function	
		box.pack_start(self.mount_buttons[0], False, False, 0)			#Packs the mount button into the button box
		self.mount_buttons[0].show()						#Shows the button

		"""All the rest of the mount buttons follow the same format as the first unless otherwise denoted"""

		# Button for F-T.1
		self.mount_buttons[1].connect("clicked", self.mounts_callback,1)
		box.pack_start(self.mount_buttons[1], False, False, 0)
		self.mount_buttons[1].show()

		# Button for F-T.2
		self.mount_buttons[2].connect("clicked", self.mounts_callback,2)
		box.pack_start(self.mount_buttons[2], False, False, 0)
		self.mount_buttons[2].show()

		# Button for F-T.3
		self.mount_buttons[3].connect("clicked", self.mounts_callback,3)
		box.pack_start(self.mount_buttons[3], False, False, 0)
		self.mount_buttons[3].show()

		# Button for F-T.4
		self.mount_buttons[4].connect("clicked", self.mounts_callback,4)
		box.pack_start(self.mount_buttons[4], False, False, 0)
		self.mount_buttons[4].show()

		# Button for F-T.5
		self.mount_buttons[5].connect("clicked", self.mounts_callback,5)
		box.pack_start(self.mount_buttons[5], False, False, 0)
		self.mount_buttons[5].show()

		# Button for BC.6,1
		self.mount_buttons[6].connect("clicked", self.mounts_callback,6)
		box2.pack_start(self.mount_buttons[6], False, False, 0)			#Here Mounts switch which box they are packed 												in for being to be placed in the second column
		self.mount_buttons[6].show()

		# Button for BC.1,2
		self.mount_buttons[7].connect("clicked", self.mounts_callback,7)
		box2.pack_start(self.mount_buttons[7], False, False, 0)
		self.mount_buttons[7].show()	

		# Button for BC.2,3
		self.mount_buttons[8].connect("clicked", self.mounts_callback,8)
		box2.pack_start(self.mount_buttons[8], False, False, 0)
		self.mount_buttons[8].show()

		# Button for BC.3,4
		self.mount_buttons[9].connect("clicked", self.mounts_callback,9)
		box2.pack_start(self.mount_buttons[9], False, False, 0)
		self.mount_buttons[9].show()

		# Button for BC.4,5
		self.mount_buttons[10].connect("clicked", self.mounts_callback,10)
		box2.pack_start(self.mount_buttons[10], False, False, 0)
		self.mount_buttons[10].show()

		# Button for BC.5,6
		self.mount_buttons[11].connect("clicked", self.mounts_callback,11)
		box2.pack_start(self.mount_buttons[11], False, False, 0)
		self.mount_buttons[11].show()

		self.table.attach(box,0,1,1,2,gtk.FILL,0,0,0)
		self.table.attach(box2,1,2,1,2,gtk.FILL,0,0,0)

		# Adds separator between button field and control panel
		separator = gtk.VSeparator()				#Creates separator line between mount buttons and control panel
        	separator.set_size_request(20, 200)			#Sets the size as 20pts wide and 200pts long
        	self.table.attach(separator, 2, 3, 1, 2, gtk.FILL, 0, 0, 0); #Adds the separator to the table
		self.window.show_all()					#Shows the separator and all other objects on the window
	
		# Create Arrow buttons
		self.arrow_buttons = self.create_arrow_buttons()	#Calls function that creates the arrow buttons
		self.control_panel = gtk.Table(6,4, False)		#Creates the control panel, a table of 6 rows, 4 cols

		# Up Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[2], 2,3,0,1, 0,0,0,0) 		#Attaches arrow button to control panel
		self.arrow_buttons[2].connect("clicked", self.push_to_move_callback,'up')	#Connects a click to the move callback
		self.arrow_buttons[2].add(self.upblack)						#Adds a black arrow icon to this button
		self.upblack.show()								#Makes the arrow icon visible


		""" All other arrow button definitions follow the same format as the one above unless otherwise noted."""

		# Down Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[3], 2,3,2,3, 0,0,0,0)		
		self.arrow_buttons[3].connect("clicked", self.push_to_move_callback,'down')
		self.arrow_buttons[3].add(self.downblack)
		self.downblack.show()
		
		# Right Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[1],3,4,1,2,0,0,0,0)				
		self.arrow_buttons[1].connect("clicked", self.push_to_move_callback,'right')
		self.arrow_buttons[1].add(self.rightblack)
		self.rightblack.show()

		# Left Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[0], 1,2,1,2, 0,0,0,0)		
		self.arrow_buttons[0].connect("clicked", self.push_to_move_callback,'left')
		self.arrow_buttons[0].add(self.leftblack)
		self.leftblack.show()

		self.entry = []							#Creates an empty array for stuff on the contol panel
		self.entrySteps = []						#Creates another empty array for stuff

		# Label for selected Picomotor
		self.entry.append(gtk.Label(picoData.label))			#Adds a text entry box to the array 
		self.entry[0].set_size_request(80,20)				#Sets the size of the text box to 80pts wide 20pts high
		self.frame0 = gtk.Frame("Active Picomotor")			#Creates a labeled frame
		self.frame0.add(self.entry[0])					#Adds a labeled frame around the text box
		self.control_panel.attach(self.frame0, 0,1,0,1, gtk.FILL,0,0,0) #Attaches entry and frame to the control panel
		
		# Step Size on X Axis
		self.entry.append(gtk.Entry())					#Adds a text entry box to the array
		self.entry[1].set_size_request(60,20)				#Sets the size of the text box to 60pts by 20pts
		self.entry[1].set_editable(True)				#Sets the text box so that it can be edited
		self.frame1 = gtk.Frame("X Axis Step Size")			#Creates a labled frame
		self.frame1.add(self.entry[1])					#Adds the labeled frame around the text box
		self.control_panel.attach(self.frame1, 0,1,4,5, gtk.FILL,gtk.FILL,0,0)	#Attaches pair to the control panel
		self.entry[1].connect("activate",self.update_step_callback, 'X')#Connects a return keystroke in the text entry to a 											function that updates the step size, passing in the 											axis on which the change is made
		self.entry[1].connect("changed", self.changed, 'X')		#Also connects the box to a function, this one 											monitors changes made without an enter keystroke, 											passing in the axis on which the change is made

		# Step Size on Y Axis
		self.entry.append(gtk.Entry())					#Adds another text entry to the array
		self.entry[2].set_size_request(60,20)				#Sets the size of the text box to 60pts by 20pts
		self.entry[2].set_editable(True)				#Sets the text box so that it can be edited
		self.frame2 = gtk.Frame("Y Axis Step Size")			#Creates a labeled frame
		self.frame2.add(self.entry[2])					#Adds the labeled frame around the text box
		self.control_panel.attach(self.frame2, 0,1,5,6, gtk.FILL,0,0,0) #Attaches the pair to the control panel
		self.entry[2].connect("activate",self.update_step_callback, 'Y')#Connects and a return keystroke in the text entry to 											a function that updates the step size, passing in the 											axis on which the change is made
		self.entry[2].connect("changed", self.changed, 'Y')		#Also connects the box to a function, this one 											monitors changes made without an enter keystroke, 											passing in the axis on which the change is made

		# Step Size Double Button
		self.double_button = gtk.Button("2X Step Size")				 #Creates a new button for doubling step size
		self.control_panel.attach(self.double_button, 0,1,3,4,gtk.FILL,0,0,0)	 #Attaches button to control panel
		self.double_button.show()						 #Makes the button visible
		self.double_button.connect("clicked",self.step_button_callback, 'double')#Attaches a click to the callback handling 								      				 the change

		# Step Size Half Button
		self.half_button = gtk.Button("1/2X Step Size")				 #Creates a new button for halving step size
		self.control_panel.attach(self.half_button, 0,1,2,3,gtk.FILL,0,0,0)	 #Attaches button to control panel
		self.half_button.show()							 #Makes the button visible
		self.half_button.connect("clicked",self.step_button_callback, 'half')	 #Attaches a click to the callback handling 												 the change
		
		# y position indicator
		self.entry.append(gtk.Label(str(self.ypos)))		#Adds an uneditable label to the array and puts the currently 										stored value of the y position in the label
		self.entry[3].set_size_request(80,20)			#Sets the size of the label to 80pts by 20pts
		self.frame3 = gtk.Frame("Y Position")			#Creates a labeled frame for the label
		self.frame3.add(self.entry[3])				#Attaches the labeled frame to the label
		self.control_panel.attach(self.frame3, 2,4,5,6, 0,0,0,0)#Attaches the pair to the control panel

		# x position indicator
		self.entry.append(gtk.Label(str(self.xpos)))		#Adds an uneditable label to the array and puts the currently 										stored value of the y position in the label
		self.entry[4].set_size_request(80,20)			#Sets the size of the label to 80pts by 20pts
		self.frame4 = gtk.Frame("X Position")			#Creates a labeled frame for the label
		self.frame4.add(self.entry[4])				#Attaches the labeledt frame to the label
		self.control_panel.attach(self.frame4, 2,4,4,5, 0,0,0,0)#Attaches the pair to the control panel


		# Status Bar
		self.statusbar = gtk.Label("Status: No Errors ")			#Creates the status bar that shows errors
		self.control_panel.attach(self.statusbar,0,6,6,7,0,gtk.SHRINK,0,0)	#Attaches the status bar to the control panel
		self.statusbar.show()							#Makes the status bar visible


		# Zeroing menu
		self.zerobar = gtk.MenuBar()				#Creates the zeroing  menu for the currently selected pico
		subzero = gtk.Menu()					#Creates the sub menu for zeroing
		zeroitem = gtk.MenuItem("Zero")				#Creates the top level menu view
        	all = gtk.MenuItem("All")				#Creates the all option for the zeroing menu
        	x = gtk.MenuItem("X axis")				#Creates the x axis option for the zeroing menu
		y = gtk.MenuItem("Y axis")				#Creates the y axis option for the zeroing menu
		subzero.append(all)					#Adds the all option to the sub menu
		subzero.append(x)					#Adds the x option to the sub menu
		subzero.append(y)					#Adds the y option to the sub menu
		zeroitem.set_submenu(subzero)				#Sets the  sub menu as a 'sub_menu'
		self.zerobar.append(zeroitem)				#Adds the'sub_menu' to the menu bar for zeroing
		self.control_panel.attach(self.zerobar, 2,3,3,4,0,0,0,0)#Attaches the zeroing menu to the control panel
		self.zerobar.show() 					#Makes the zeroing menu visible
		
		# Zeroing menu Callbacks
		all.connect("activate",self.zero_callback, 'all')	#Attaches the all zeroing option to the zeroing callback and 										passes in that all has been selected
		x.connect("activate",self.zero_callback, 'x')		#Attaches the  x axis option to the zeroing callback and 										passes in that x has been selected
		y.connect("activate",self.zero_callback, 'y')		#Attaches the y axis option to the zeroing callback and 									passes in that x has been selected

		self.table.attach(self.control_panel,3,4,1,2,gtk.FILL,0,0,0)	#Attaches the table to the control panel, making the control 										panel work
		
	# Sets label on picomotor selection and Loads control of selected picomotor.
	def mounts_callback(self, widget, num):	#Beginning of function definition num is the number of the mounts that has been 						selected and is passed into the function
		
		
		self.window.show_all()								#Sets everything as visible
		picoData.label = picoData.picoId.field('picoId')[num*2]				#Retrieves the name of the selected 													mount from the lookup table in 													picoData.py
		self.entry[0].set_text(picoData.label)						#Sets the selected picomotor label to 													the name of the selected mount
		picoName = picoData.label							#Sets picoName variable equal to the 													retrived name of the mount
		picoIP = picoData.getFieldValue(picoData.picoId, 'IP', 'picoId', picoName)	#Retrives the IP adress of the 													selected pico from the lookup table in 													picoData.py
        	index, = picoData.picoId.field('picoId').match(picoName)			#Puts the values of the two picomotors 													associated with a particular mount 													into the array index as they appear in 													the look uptable in picoData.py
        	nAxis = "this is nAxis", len(index)								#nAxis is the number of axis present 													in this application it could be 												listed, but this finds the number of 													axis by looking at the number of 													entries in index
		print str(nAxis)		
		self.index = index								#Makes the index array global 
		self.xpos = picoData.location[index[0]]						#Updates the x postion for the 													selected mount as it appears in the 													storage array in picoData.py
		self.ypos = picoData.location[index[1]]						#Updates the y postion for the 													selected mount as it appears in the 													storage array in picoData.py
		self.entry[4].set_text(str(picoData.location[index[0]]))			#Updates the x postition text entry 													upon selection of a new mount to the 													position values for that mount stored 													in picoData.py
		self.entry[3].set_text(str(picoData.location[index[1]]))			#Updates the x postition text entry 													upon selection of a new mount to the 													position values for that mount stored 													in picoData.py

		self.driver = picoData.picoId.field('driver')[index]				#Loads the drivers names that the 													selected mount's picos reside on
		self.motor = picoData.picoId.field('motor')[index]				#Loads the motors that the selected 													mount's picos are on (driver channel)
		self.steps = PicoLib.array([50]*nAxis)						#This sets the default step size that 													loads each time a new mount is selected
		print "picoName = ", picoName							#Prints  selected mount name 
        	print "available axis: ", picoData.picoId.field('axis')[index]			#Prints the axes that are availabel X&Y
		print "picoIP = ", picoIP							#Prints the IP Adress of the picos
		print self.motor								#Prints the motor that eh picos are on

		# Intialization of the telnet connection with the picoMotor
        	if picoData.select_Flag == False:						#Checks to see if a mount has 													previously been selected protecting 													against trying to make multiple telnet 													connections, only one may be made
			picoLowLevel.PicoControl.__init__(self, picoIP)				#Opens telnet as per existing 													picoLowLevel.py function
      			print "self.tn.host = ", self.tn.host					#Prints host name of telnet connection
		for i in range(nAxis):								#Allows useable axis to be addressed
	        	self.SetVelocity(self.driver[i], self.motor[i], 2000)			#Sets a default velocity to the picos
		self.entry[1].set_text(str(self.steps[0]))					#Sets X default step size
		self.entry[2].set_text(str(self.steps[1]))					#Sets Y default step size
		picoData.select_Flag = True							#Sets flag that mount has been 													selected thus telnet has been opened
		self.update_step_callback(widget, 'X')						#Forces update of x step size as if 													enter has been pressed
		self.update_step_callback(widget, 'Y')						#Forces update of y step size as if 													enter has been pressed
	
	# Updates step size when enter is pressed in the text box	
	def update_step_callback(self, widget, axis):			#Initialization of the function
		if axis == 'X':						#This group of if statements gets which axis is input and
			pointer = 1					#assigns a variable used later to reflect which axis is entered
		if axis == 'Y':
			pointer = 2
		text = (self.entry[pointer].get_text())			#Gets the text from the text box of the specified axis
		test = self.character_test(text)			#Runs the text in the text box through a function that tests 										for the prescence of letters and returns a true or false
		if test == False:					#If no letters are found, false is returned
			ntext = int(text)				#The text from the text box is brought in as a sting, this 										converts the string to a group of integer
			if 0 < ntext <= 1000 :				#Checks if the value  of the text box entry falls within range
				if axis == 'X':				#Checks axis
					

			#Here,Yellow arrows on the X axis buttons are turned to black arrows
					if self.xcol == 'yellow':			      #Checks color
						self.statusbar.set_text("Status: No Errors.") #Updateds status to reflect arrow color
						self.arrow_buttons[0].remove(self.leftyellow) #Removes yellow arrow pointing left
						self.arrow_buttons[1].remove(self.rightyellow)#Removes yellow arrow pointing right
						self.arrow_buttons[0].add(self.leftblack)     #Adds black arrow pointing left
						self.arrow_buttons[1].add(self.rightblack)    #Adds black arrow pointing right
						self.leftblack.show()			      #Makes black arrow left icon visible
						self.rightblack.show()			      #Makes black arrow right icon visible
						self.xcol = 'black'			      #Updates X axis color marker
			#Here, Red arrows on the X axis buttons are turned to black arrows
					if self.xcol == 'red':				      #Checks color
						self.statusbar.set_text("Status: No Errors.") #Updates status to reflect arrow color
						self.arrow_buttons[0].remove(self.leftred)    #Removes red arrow pointing left
						self.arrow_buttons[1].remove(self.rightred)   #Removes red arrow pointing right
						self.arrow_buttons[0].add(self.leftblack)     #Adds black arrow pointing left
						self.arrow_buttons[1].add(self.rightblack)    #Adds black arrow pointing right
						self.leftblack.show()			      #Makes black arrow left icon visible
						self.rightblack.show()			      #Makes black arrow right icon visible
						self.xcol = 'black'			      #Updates X axis color marker
						
				if axis == 'Y':							#Checks axis
			# Here, Yellow arrows on the Y axis buttons are turned to black 
					if self.ycol == 'yellow':				#Checks color
						self.statusbar.set_text("Status: No Errors.")	#Updates status to reflect arrow color
						self.arrow_buttons[2].remove(self.upyellow)	#Removes yellow arrow pointing up
						self.arrow_buttons[3].remove(self.downyellow)	#Removes yellow arrow pointing down
						self.arrow_buttons[2].add(self.upblack)		#Adds black arrow pointing up
						self.arrow_buttons[3].add(self.downblack)	#Adds black arrow pointing down
						self.upblack.show()				#Makes black arrow up visible
						self.downblack.show()				#Makes black arrow down visible
						self.ycol = 'black'				#Updates Y axis color marker
			#Here, Red arrows on the y axis buttons are turned to black
					if self.ycol == 'red':					#Checks color
						self.statusbar.set_text("Status: No Errors.")	#Updates status to reflect arrow color
						self.arrow_buttons[2].remove(self.upred)	#Removes red arrow pointing up
						self.arrow_buttons[3].remove(self.downred)	#Removes red arrow pointing down
						self.arrow_buttons[2].add(self.upblack)		#Adds black arrow pointing up
						self.arrow_buttons[3].add(self.downblack)	#Adds black arrow pointing down
						self.upblack.show()				#Makes black arrow up visible
						self.downblack.show()				#Makes black arrow down visible
						self.ycol = 'black'				#Updates Y axis color marker

				newsteps = self.entry[pointer].get_text()			#Value is retrieved from entry box
				self.steps[pointer-1] = int(newsteps)				#Now text entry is made new step size
				print "New step size: %d\n" % self.steps[pointer-1]		#Prints new step size to command window
			# Else catches instances in which entry is out of range
			else:	
				if axis == 'X':							#Checks axis
			#Here, black arrows on the X axis are turned to red
					if self.xcol == 'black':				#Checks color
						self.statusbar.set_text("Status: Invalid Step Entry! Out of Range.")#Updates status to 															    reflect arrow color
						self.arrow_buttons[0].remove(self.leftblack)	#Removes black arrow pointing left
						self.arrow_buttons[1].remove(self.rightblack)	#Removes black arrow pointing right
						self.arrow_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.arrow_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red arrow left visible
						self.rightred.show()				#Makes red arrow right visible
						self.xcol = 'red'				#Updates X axis color marker
			#Here, yellow arrows on the X axis are turned to red
					if self.xcol == 'yellow':				#Checks color
						self.statusbar.set_text("Status: Invalid Step Entry! Out of Range.")#Updates status to 															    reflect arrow color
						self.arrow_buttons[0].remove(self.leftyellow)	#Removes yellow arrow pointing left
						self.arrow_buttons[1].remove(self.rightyellow)	#Removes yellow arrow pointing right
						self.arrow_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.arrow_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red arrow left visible
						self.rightred.show()				#Makes red arrow right visible
						self.xcol = 'red'				#Updates X axis color marker

				if axis == 'Y':							#Checks axis	
			#Here, black arrows on the Y axis are turned to red		
					if self.ycol == 'black':				#Checks color
						self.statusbar.set_text("Status: Invalid Step Entry! Out of Range.")#Updates status to 															    reflect arrow color
						self.arrow_buttons[2].remove(self.upblack)	#Removes black arrow pointing up
						self.arrow_buttons[3].remove(self.downblack)	#Removes black arrow pointing down
						self.arrow_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.arrow_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red up arrow visible
						self.downred.show()				#Makes red down arrow visible
						self.ycol = 'red'				#Updates Y axis color marker
			#Here, yellow arrows on the Y axis are turned to red
					if self.ycol == 'yellow':				#Checks color
						self.statusbar.set_text("Status: Invalid Step Entry! Out of Range.")#Updates status to 															    reflect arrow color
						self.arrow_buttons[2].remove(self.upyellow)	#Removes yellow arrow pointing up
						self.arrow_buttons[3].remove(self.downyellow)	#Removes yellow arrow pointing down
						self.arrow_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.arrow_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red arrow up visible
						self.downred.show()				#Makes red arrow down visible
						self.ycol = 'red' 				#Updates Y axis color marker
			# Else catches instances in which letters are found
	   	else:	
			if axis == 'X':								#Checks axis
			#Here, black arrows on the X axis are turned to red
				if self.xcol == 'black':					#Checks Color
					self.statusbar.set_text("Status: Invalid Step Entry! Contains Letters.")#Updates status to 															reflect arrow color
					self.arrow_buttons[0].remove(self.leftblack)		#Removes black arrow pointing left
					self.arrow_buttons[1].remove(self.rightblack)		#Removes black arrow pointing right
					self.arrow_buttons[0].add(self.leftred)			#Adds red arrow pointing left
					self.arrow_buttons[1].add(self.rightred)		#Adds red arrow pointing right
					self.leftred.show()					#Makes red arrow left visible
					self.rightred.show()					#Makes red arrow right visible
					self.xcol = 'red'					#Updates X axis color marker
			#Here, yellow arrow on the X axis are turned to red
				if self.xcol == 'yellow':					#Checks Color
					self.statusbar.set_text("Status: Invalid Step Entry! Contains Letters.")#Updates status to 															reflect arrow color
					self.arrow_buttons[0].remove(self.leftyellow)		#Removes yellow arrow pointing left
					self.arrow_buttons[1].remove(self.rightyellow)		#Removes yellow arrow pointing right
					self.arrow_buttons[0].add(self.leftred)			#Adds red arrow pointing left
					self.arrow_buttons[1].add(self.rightred)		#Adds red arrow pointing right
					self.leftred.show()					#Makes red arrow left visible
					self.rightred.show()					#Makes red arrow right visible
					self.xcol = 'red'					#Updates X axis color marker
				
			if axis == 'Y':								#Checks axis
			#Here, black arrows on the Y axis are turned to red
				if self.ycol == 'black':					#Checks color
					self.statusbar.set_text("Status: Invalid Step Entry! Contains Letters.")#Updates status to 															reflect arrow color
					self.arrow_buttons[2].remove(self.upblack)		#Removes black arrow pointing up
					self.arrow_buttons[3].remove(self.downblack)		#Removes black arrow pointing down
					self.arrow_buttons[2].add(self.upred)			#Adds red arrow pointing up
					self.arrow_buttons[3].add(self.downred)			#Adds red arrow pointing down
					self.upred.show()					#Makes red arrow up visible
					self.downred.show()					#Makes red arrow down visible
					self.ycol = 'red'					#Updates Y axis color marker
		#Here, yellow arrow on the Y axis are turned to red
				if self.ycol == 'yellow':					#Checks color
					self.statusbar.set_text("Status: Invalid Step Entry! Contains Letters.")#Updates status to 															reflect arrow color
					self.arrow_buttons[2].remove(self.upyellow)		#Removes yellow arrow pointing up
					self.arrow_buttons[3].remove(self.downyellow)		#Removes yellow arrow pointing down
					self.arrow_buttons[2].add(self.upred)			#Adds red arrow pointing up
					self.arrow_buttons[3].add(self.downred)			#Adds red arrow pointing down
					self.upred.show()					#Makes red up arrow visible
					self.downred.show()					#Makes red down arrow visible
					self.ycol = 'red' 					#Updates Y axis color marker


	#This function checks each time there is any change in a text entry box whether or not the entry meets the criteria of  the range from 0 - 1000 as well as the absence of letters.

	# Callback for changed step size
	def changed(self, widget, which):							#Initialization of the function
		if which == 'X':								#Folllowing group of ifs checks which
			pointer = 1								#axis is being checked and specifies it
		if which == 'Y':								#for use in the function
			pointer = 2
		text = (self.entry[pointer].get_text())						#Text from box is brought in
		test = self.character_test(text)						#Text is checked for letters
		if self.firsttime == False:							#During the program initialization there is a sequence that causes a step size error, this flag is used to avoid the error by not allowing the change that would be made if allowed to moniter the set-up sequence for the step size / entry box.

			#Only entries without letters are evaluated in this part
			if test == False:							#Confirms letter absence 	
				if which == 'X':						#Checks axis
					flag = 1						#Variable for avoiding error mentioned 													above
			#Here, black arrows on the X axis are turned to yellow
					if self.xcol == 'black':				#Color is checked
						self.statusbar.set_text("Status: Step size changed but not updated.")#Status is 														     updated to match 															     arrow color 
						self.arrow_buttons[0].remove(self.leftblack)	#Removes black arrow pointing left
						self.arrow_buttons[1].remove(self.rightblack)	#Removes black arrow pointing right
						self.arrow_buttons[0].add(self.leftyellow)	#Adds yellow arrow pointing left
						self.arrow_buttons[1].add(self.rightyellow)	#Adds yellow arrow pointing right
						self.leftyellow.show()				#Makes yellow left arrow visible
						self.rightyellow.show()				#Makes yellow right arrow visible
						self.xcol = 'yellow'				#Updates X axis color marker

			#Here, red arrows on the X axis are turned to yellow
					if self.xcol == 'red':					#Color checked
						self.statusbar.set_text("Status: Step size changed but not updated.")#Status is 														     updated to match 															     arrow color
						self.arrow_buttons[0].remove(self.leftred)	#Removes red arrow pointing left
						self.arrow_buttons[1].remove(self.rightred)	#Removes red arrow pointing right
						self.arrow_buttons[0].add(self.leftyellow)	#Adds yellow arrow pointing left
						self.arrow_buttons[1].add(self.rightyellow)	#Adds yellow arrow pointing right
						self.leftyellow.show()				#Makes yellow left arrow visible
						self.rightyellow.show()				#Makes yellow right arrow visible
						self.xcol = 'yellow'				#Updates X axis color marker

				elif which == 'Y':						#Checks axis
					flag = 1						#Variable for avoiging error mentioned 													above
			# Here, black arrows on the Y axis are turned to yellow
					if self.ycol == 'black':				#Color checked
						self.statusbar.set_text("Status: Step size changed but not updated.")#Status is 														     updated to match 															     arrow color
						self.arrow_buttons[2].remove(self.upblack)	#Removes black arrow pointing up
						self.arrow_buttons[3].remove(self.downblack)	#Removes black arrow pointing down
						self.arrow_buttons[2].add(self.upyellow)	#Adds yellow arrow pointing up
						self.arrow_buttons[3].add(self.downyellow)	#Adds yellow arrow pointing down
						self.upyellow.show()				#Makes yellow up arrow visible
						self.downyellow.show()				#Makes yellow down arrow visible
						self.ycol = 'yellow'				#Updates Y axis color marker

			#Here, red arrows on the Y axis are turned to yellow
					if self.ycol == 'red':					#Color checked
						self.statusbar.set_text("Status: Step size changed but not updated.")#Status is 														     updated to match 															     arrow color
						self.arrow_buttons[2].remove(self.upred)	#Removes red arrow pointing up
						self.arrow_buttons[3].remove(self.downred)	#Removes red arrow pointing down
						self.arrow_buttons[2].add(self.upyellow)	#Adds yellow arrow pointing up
						self.arrow_buttons[3].add(self.downyellow)	#Adds yellow arrow pointing down
						self.upyellow.show()				#Makes yellow up arrow visible
						self.downyellow.show()				#Makes yellow down arrow visible
						self.ycol = 'yellow'				#Updates Y axis color marker

			# Else catches instances containing letter
			else:
				if which == 'X':						#Axis is checked
			#Here, black arrows on the X axis are turned to red
					if self.xcol == 'black':				#Color checked
						self.statusbar.set_text("Status: Invalid Step Size! Entry contains letters.")#Status 															 is updated to 															match arrow color
						self.arrow_buttons[0].remove(self.leftblack)	#Removes black arrow pointing left
						self.arrow_buttons[1].remove(self.rightblack)	#Removes black arrow pointing right
						self.arrow_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.arrow_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red left arrow visible
						self.rightred.show()				#Makes red right arrow visible
						self.xcol = 'red'				#Updates X axis color marker

			#Here, yellow arrows on the X axis are turned to red
					if self.xcol == 'yellow':				#Color is checked
						self.statusbar.set_text("Status: Invalid Step Size! Entry contains letters.")#Status 																is updated to 															match arrow color
						self.arrow_buttons[0].remove(self.leftyellow)	#Removes yellow arrow pointing left
						self.arrow_buttons[1].remove(self.rightyellow)	#Removes yellow arrow pointing right
						self.arrow_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.arrow_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red left arrow visible
						self.rightred.show()				#Makes red left arrowvisible
						self.xcol = 'red'				#Updates X axis color marker 


				if which == 'Y':						#Checks axis
			#Here, black arrows on the Y axis are turned to red
					if self.ycol == 'black':				#Checks color
						self.statusbar.set_text("Status: Invalid Step Size! Entry contains letters.")#Status 														updated to match arrow color
						self.arrow_buttons[2].remove(self.upblack)	#Removes black arrow pointing up
						self.arrow_buttons[3].remove(self.downblack)	#Removes black arrow pointing down
						self.arrow_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.arrow_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red up arrow visible
						self.downred.show()				#Makes red down arrow visible
						self.ycol = 'red'				#Updates Y axis color marker

			# Here, yellow arrows on the Y axis are turned to red
					if self.ycol == 'yellow':				#Color is checked
						self.statusbar.set_text("Status: Invalid Step Size! Entry contains letters.")#Status 														updated to match arrow color
						self.arrow_buttons[2].remove(self.upyellow)	#Removes yellow arrow pointing up
						self.arrow_buttons[3].remove(self.downyellow)	#Removes yellow arrow pointing down
						self.arrow_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.arrow_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red up arrow visible
						self.downred.show()				#Makes red down arrow visible
						self.ycol = 'red'				#Updates Y axix color marker

			#Else takes care of error mentioned at top of function, simply counts off number of queries made during the set up sequence so the error is avoided.
		else: 
			if self.count >= 2:
				self.firsttime = False
			else:
				self.count = self.count + 1


			# This function calls to PicoLowLevel.py for telnet commands that move the pico motors

	# Moves picomotor at push of arrow button.
	def push_to_move_callback(self, widget, axis):						#Definition of Function, axis passed in
		print "WE ARE HERE"
		if self.ycol == 'black':							#Statement only allows pico movement 													if color is black(denoting no errors)
			if axis == 'up':							#Up button pressed
				self.MoveRelative(self.driver[1],self.motor[1],-self.steps[1])	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.ypos += self.steps[1]					#Updates internal pico position
				self.entry[3].set_text(str(self.ypos))				#Updates pico position entry on 												control panel
				picoData.location[self.index[1]] = self.ypos			#Updates position in picoData.py
			if axis == 'down':							#Down button pressed
				self.MoveRelative(self.driver[1],self.motor[1],self.steps[1])	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.ypos -= self.steps[1]					#Updates internal pico position
				self.entry[3].set_text(str(self.ypos))				#Updates pico position entry on 												control panel
				picoData.location[self.index[1]] = self.ypos			#Updates position in picoData.py
		if self.xcol == 'black':							#Statement only allows pico movement 													if color is black(denoting no errors)
			if axis == 'left':							#Left button pressed
				self.MoveRelative(self.driver[0],self.motor[0],self.steps[0])	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.xpos -= self.steps[0]					#Updates internal pico position
				self.entry[4].set_text(str(self.xpos))				#Updates pico position entry on 												control panel
				picoData.location[self.index[0]] = self.xpos			#Updates position in picoData.py
			if axis == 'right':							#Right button pressed
				self.MoveRelative(self.driver[0],self.motor[0], -self.steps[0])	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.xpos += self.steps[0]					#Updates internal pico position
				self.entry[4].set_text(str(self.xpos))				#Updates pico position entry on 												control panel			
				picoData.location[self.index[0]] = self.xpos			#Updates position in picoData.py
	
			# Function  zeros the currently selected mount's picomotor positions with the option of choosing either axis or both

	# Zero callback
	def zero_callback(self, widget, which):						#Initializes function, which = axis
		if which == 'x':							#Checks axis
			self.xpos = 0							#Zeros internal X pico position
			self.entry[4].set_text(str(self.xpos))				#Zeros X pico position entry on control panel
			picoData.location[self.index[0]] = 0				#Zeros X postion stored in picoData.py
		if which == 'y':							#Checks axis
			self.ypos = 0							#Zeros internal Y pico position
			self.entry[3].set_text(str(self.ypos))				#Zeros Y pico position on control panel
			picoData.location[self.index[1]] = 0				#Zeros Y position in picoData.py
		if which == 'all':							#Checks axis
			self.xpos = 0							#Zeros internal pico position X axis
			self.ypos = 0							#Zeros internal pico position Y axis
			self.entry[4].set_text(str(self.xpos))				#Zeros X pico position entry on control panel 
			self.entry[3].set_text(str(self.ypos))				#Zeros Y pico position entry on control panel
			picoData.location[self.index[1]] = 0				#Zeros X position in picoData.py
			picoData.location[self.index[0]] = 0				#Zeros Y position in picoData.py

			#Function zeros each axis for all picomotors on the system

	#Zero All callback
	def zeroall_callback(self, widget, var):	#Initializes function, var is a variable passed from the confirmation window
		if var == 'yes':					#Checks if yes button has been pressed
			n = 0						#Count variable initialized
			while n < len(picoData.location):		#While loop passes over all pico positions stored in picoData
				picoData.location[n] = 0		#Sets each of the values at these postitions to zero
				n = n + 1				#Adds one to the count n++ doesn't work?!
			self.xpos = 0					#Internal X pico position zeroed
			self.ypos = 0					#Internal Y pico position zeroed
			self.entry[4].set_text(str(0))			#X axis position entry on the control panel zeroed
			self.entry[3].set_text(str(0))			#Y axis position entry on the control panel zeroed
		self.qwindow.destroy()					#Closes confirmation window for zeroing all positions

		#This function doubles or halves the step size of both X and Y step size depending on which button is pressed

	# Step Size Double Button Callback
	def step_button_callback(self, widget, increment):		#Initializes function, increment passed from button, 1/2x or 2x
		if increment == 'half':					#This part deals with halving the step size
			self.steps[0] = self.steps[0] * .5		#Halves X step size
			self.steps[1] = self.steps[1] * .5		#Halves Y step size
			self.entry[1].set_text(str(self.steps[0]))	#Updates X step size entry on control panel
			self.entry[2].set_text(str(self.steps[1]))	#Updates Y step size entry on control panel

		if increment == 'double':				#This part deals with doubling the step size
			self.steps = self.steps * 2			#More effectively doubles the step size than halving above
			self.entry[1].set_text(str(self.steps[0]))	#Updates X step size entry on control panel
			self.entry[2].set_text(str(self.steps[1]))	#Updates Y step size entry on control panel
		self.update_step_callback(widget, 'X')			#Forces callback for X step size-like pressing enter in the box
		self.update_step_callback(widget, 'Y')			#Forces callback for Y step size-like pressing enter in the box
		self.xpos = picoData.location[index[0]]			#Sets X position of internal variable equal with picoData
		self.ypos = picoData.location[index[1]]			#Sets Y position of internal variable equal with picoData


	# Create icons for mounts to place on buttons
	def create_mount_buttons(self):					#Initializes function, no variables passed in
		mount_buttons = []					#Creates empty array
		for n in range(12):					#Runs through 12 times one for each mount in the system
			mount_buttons.append(gtk.Button())		#Adds a new entry to the array
			if n < 6:					#For the first six icons
				image = mounts.makeIcon('right')	#They face right
			else:						#The rest
				image = mounts.makeIcon('left')		#Well they face left
			mount_buttons[n].add(image)			#Now each icon is put onto a button!
		return mount_buttons					#Finally the array of buttons is returned.Yay!

	# Create icons for arrows to place on buttons
	def create_arrow_buttons(self):					#Initializes function, no variables passed in
		arrow_buttons = []					#Empty array is created
		
#Code was changed from each colored arrow having it's own button to only four buttons on which different icons would be placed, code structure follows the pattern of creating a button for each icon, but has been edited so that only four buttons are created and global icons are created, kind of silly really

		arrow_buttons.append(gtk.Button())			#Creates button #1			
		self.leftblack = arrows.makeIcon('left')		#Creates black arrow pointing left
		arrow_buttons.append(gtk.Button())			#Creates button #2
		self.rightblack = arrows.makeIcon('right')		#Creates black arrow pointing right
		arrow_buttons.append(gtk.Button())			#Creates button #3
		self.upblack = arrows.makeIcon('up')			#Creates black arrow pointing up
		arrow_buttons.append(gtk.Button())			#Creates button #4
		self.downblack = arrows.makeIcon('down')		#Creates black arrow pointing dow
		self.leftred = arrows.makeIcon('leftr')			#Creates red arrow pointing left
		self.rightred = arrows.makeIcon('rightr')		#Creates red arrow pointing right
		self.upred = arrows.makeIcon('upr')			#Creates red arrow pointing up
		self.downred = arrows.makeIcon('downr')			#Creates red arrow pointing down
		self.leftyellow = arrows.makeIcon('lefty')		#Creates yellow arrow pointing left
		self.rightyellow = arrows.makeIcon('righty')		#Creates yellow arrow pointing right
		self.upyellow = arrows.makeIcon('upy')			#Creates yellow arrow pointing up
		self.downyellow = arrows.makeIcon('downy')		#Creates yellow arrow pointing down
		return arrow_buttons					#Returns the array of 4 buttons
		

	#Test that checks to see if there are letters in a string, or well, I guess it just checks that there isn't any thing thats not a number.
	def character_test(self, string):			#Initialization of function, passes in a string
		i=0						#Count variable
		flag = False					#False unles otherwise found
		while i <= len(string):				#While loop goes thought the entire length of the string
			if string[i-1:i] == "0":		#Looks at a specific location in the sdtring, funny colonization 								specifes current looking position
				flag = False			#Kinda usless to re-assert this
			elif string[i-1:i] == "1":
				flag = False
			elif string[i-1:i] == "2":
				flag = False
			elif string[i-1:i] == "3":
				flag = False
			elif string[i-1:i] == "4":
				flag = False
			elif string[i-1:i] == "5":
				flag = False
			elif string[i-1:i] == "6":
				flag = False
			elif string[i-1:i] == "7":
				flag = False
			elif string[i-1:i] == "8":
				flag = False
			elif string[i-1:i] == "9":
				flag = False
			else:
				flag = True
			i=i+1
		return flag					#Returns True-has letters or False-no letters



	#This function opens a window when you click on zero all in the menu, it asks whether you want to do it or not

	def Zero_or_No(self,widget):						#Initializes window function
        	self.qwindow = gtk.Window(gtk.WINDOW_TOPLEVEL)			#Creates a new top level window
        	self.qwindow.set_title(" ")					#I gave it no title
        	self.qwindow.set_border_width(10)				#Just sets the border width of the window
		table = gtk.Table(7,5 , True)					#Creates a table 7 rows, 5 cols, all cell same size
		label = gtk.Label("Are you sure you want to zero all of the postions?") #Creates label
		table.attach(label, 0,7,2,3,0,0,0,0)				#Attaches label to table
		label.show()							#Makes the label visible on the window
		# Yes Button
		yes = gtk.Button("Zero Them")					#Confirmation button is created
		table.attach(yes,2,3,3,4,0,0,0,0)				#Attaches confirmation button to table
		yes.show()							#Makes confirmation button visible on the window
		yes.connect("clicked",self.zeroall_callback, 'yes')		#Connects a click on the confirmation button to 										callback
		# No Button
		close = gtk.Button("No")					#No button is created
		table.attach(close,4,5,3,4,0,0,0,0)				#No button is attached to the table
		close.show()							#No button made visible on the window
		close.connect("clicked",self.zeroall_callback, 'no')		#Connects a click on the no button to the callback
		table.show()							#Makes the no button visible on the window
		self.qwindow.add(table)						#Adds the table onto the window
        	self.qwindow.show()						#Makes the window visible
		
		

# following makes everything work, I don't know exactly how they work, but they just do.


	def main(self):
		gtk.main()		

if __name__ == "__main__":
	base=Base()	
	base.main()



